//---------------------------------------------------------------------------
#include <vcl\vcl.h>
//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#include "TPlayerSetupForm.h"
#include "TMainForm.h"
#include "TGameForm.h"
#include "TStatusForm.h"
//---------------------------------------------------------------------------
#pragma link "TDPName"
#pragma link "TDPChat"
//---------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TPlayerSetupForm *PlayerSetupForm;
//---------------------------------------------------------------------------
__fastcall TPlayerSetupForm::TPlayerSetupForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::CreatePlayerButtonClick(TObject *Sender)
{
if (MainForm->NumPlayers<MAX_PLAYERS)
	{
	// create a player & save the player's unique ID # into PlayerIDs[]
	DPName1->ShortNameA = PlayerNameEdit->Text;
	DPName1->LongNameA = PlayerNameEdit->Text+" - [ Player #"+IntToStr( MainForm->NumPlayers ) + "]";
	if (MainForm->Dx_Play1->CreatePlayer( &MainForm->PlayerIDs[MainForm->NumPlayers], DPName1, NULL, 0, 0 ))
		{
        MainForm->NumPlayers++;
        EnumAllPlayersButtonClick(this);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::Button2Click(TObject *Sender)
{
if (MainForm->NumPlayers>0)
	{
    // destroy a particular player (last one if none selected)
    int player = PlayerIDListBox->ItemIndex;
    if (player==-1) player = MainForm->NumPlayers-1;

    MainForm->Dx_Play1->DestroyPlayer( MainForm->PlayerIDs[player] );

    delete MainForm->PlayerNames[player];
    for (int i=player;i<MainForm->NumPlayers-1;i++)
    	{
        MainForm->PlayerIDs[i] = MainForm->PlayerIDs[i+1];
        MainForm->PlayerNames[i] = MainForm->PlayerNames[i+1];
        MainForm->PlayerPlayerTypes[i] = MainForm->PlayerPlayerTypes[i+1];
        MainForm->PlayerFlags[i] = MainForm->PlayerFlags[i+1];
        }
    MainForm->PlayerIDs[MainForm->NumPlayers-1] = 0;
    MainForm->PlayerNames[MainForm->NumPlayers-1] = NULL;
    MainForm->PlayerPlayerTypes[MainForm->NumPlayers-1] = 0;
    MainForm->PlayerFlags[MainForm->NumPlayers-1] = 0;

    MainForm->NumPlayers--;

    // update status
    EnumAllPlayersButtonClick(this);
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::FormShow(TObject *Sender)
{
Top=StatusForm->Height+1;
Left=0;

// setup the game
if (MainForm->I_Am_The_Host)
	{
	if (MainForm->NumPlayers==0)
		{
        // create default player for this hosting machine
	    CreatePlayerButtonClick(this);
	    }
    }
else
	{
    // ask the host for the info
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::PlayerIDListBoxClick(TObject *Sender)
{
ListBox1->ItemIndex = PlayerIDListBox->ItemIndex;
PlayerNamesListBox->ItemIndex = PlayerIDListBox->ItemIndex;
if (PlayerNamesListBox->ItemIndex!=-1) PlayerNameEdit->Text = PlayerNamesListBox->Items->Strings[ PlayerNamesListBox->ItemIndex ];	
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::Button1Click(TObject *Sender)
{
GameForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::Button5Click(TObject *Sender)
{
// Create Group
if (MainForm->NumGroups<MAX_GROUPS)
	{
    DPName1->ShortNameA = "Group #"+IntToStr(MainForm->NumGroups);
    DPName1->LongNameA = "Group #"+IntToStr(MainForm->NumGroups)+" [id:"+IntToStr(MainForm->GroupIDs[MainForm->NumGroups])+"]";
	if (MainForm->Dx_Play1->CreateGroup( &MainForm->GroupIDs[MainForm->NumGroups], DPName1, NULL, 0, 0))
    	{
        ShowMessage("Created "+DPName1->LongNameA );

        // update groups info
        EnumGroupsButtonClick(this);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::Button6Click(TObject *Sender)
{
if (MainForm->NumGroups>0)
	{
    // destroy a particular player (last one if none selected)
    int group = EnumGroupsListBox->ItemIndex;
    if (group==-1) group = MainForm->NumGroups-1;

    ShowMessage("Deleting Group #"+IntToStr(group)+" [id:"+IntToStr(MainForm->GroupIDs[group])+"]");
    if (MainForm->Dx_Play1->DestroyGroup( MainForm->GroupIDs[group] ))
    	{
        ShowMessage("deletion success");
        }
	else
        ShowMessage("deletion failed");

    // update groups info
    EnumGroupsButtonClick(this);
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::EnumGroupsButtonClick(TObject *Sender)
{
for (int i=0;i<MainForm->NumGroups;i++)
    if (MainForm->GroupNames[i]) delete MainForm->GroupNames[i];

EnumGroupsListBox->Items->Clear();
MainForm->NumGroups = 0;
MainForm->Dx_Play1->EnumGroups( NULL, NULL, DPENUMGROUPS_ALL );

// update status
StatusForm->NumGroupsLabel->Caption = IntToStr(MainForm->NumGroups) + " Groups";
}
//---------------------------------------------------------------------------
static int TotalGroupsInGroupsCreated = 0;
void __fastcall TPlayerSetupForm::Button7Click(TObject *Sender)
{
// Create Group In Group
if (MainForm->NumGroups<MAX_GROUPS)
	{
    int group = StrToInt( GroupsInGroupsEdit->Text );
    if (group==-1) group = 0;

    DPName1->ShortNameA = "Group #"+IntToStr(TotalGroupsInGroupsCreated) + " in Group #"+IntToStr(group);
    DPName1->LongNameA = "Group #"+IntToStr(MainForm->NumGroupsInGroups)+" [id:"+IntToStr(MainForm->GroupsInGroupsIDs[MainForm->NumGroupsInGroups])+"] In Group #"+IntToStr(group)+" [id:"+IntToStr(MainForm->GroupIDs[group])+"]";
	if (MainForm->Dx_Play1->CreateGroupInGroup( MainForm->GroupIDs[group], &MainForm->GroupsInGroupsIDs[MainForm->NumGroupsInGroups], DPName1, NULL, 0, 0))
    	{
        TotalGroupsInGroupsCreated++;
        ShowMessage("Created "+DPName1->LongNameA );

	    // update status
        EnumGroupsInGroupsButtonClick(this);
        }

    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::Button8Click(TObject *Sender)
{
if (MainForm->NumGroupsInGroups>0)
	{
    // destroy a particular group
    int group = StrToInt( GroupsInGroupsEdit->Text );
    if (group==-1) group = 0;

    int group_in_group = EnumGroupsInGroupsListBox->ItemIndex;
    if (group_in_group==-1) group_in_group=0;

    ShowMessage("Deleting Group #"+IntToStr(group_in_group)+" [id:"+IntToStr(MainForm->GroupsInGroupsIDs[group_in_group])+"] of Group #"+IntToStr(group)+" [id:"+IntToStr(MainForm->GroupIDs[group])+"]");

// note:
//
// you would expect to use DeleteGroupFromGroup() but this does not work.
// instead, you need to call DestroyGroup() as specified in the DirectX SDK.
//
//    if (MainForm->Dx_Play1->DeleteGroupFromGroup( MainForm->GroupIDs[group], MainForm->GroupsInGroupsIDs[group_in_group] ))
//
    if (MainForm->Dx_Play1->DestroyGroup( MainForm->GroupsInGroupsIDs[group_in_group] ))
    	{
        ShowMessage("deletion success");
    	TotalGroupsInGroupsCreated--;
        }
	else
        ShowMessage("deletion failed");

    // update status
    EnumGroupsInGroupsButtonClick(this);
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::EnumGroupsInGroupsButtonClick(TObject *Sender)
{
for (int i=0;i<MainForm->NumGroupsInGroups;i++)
    if (MainForm->GroupsInGroupsNames[i]) delete MainForm->GroupsInGroupsNames[i];

int group = StrToInt( GroupsInGroupsEdit->Text );
EnumGroupsInGroupsListBox->Items->Clear();
MainForm->NumGroupsInGroups = 0;
MainForm->Dx_Play1->EnumGroupsInGroup( MainForm->GroupIDs[group], NULL, NULL, DPENUMGROUPS_ALL );

ShowMessage("Found: "+IntToStr(MainForm->NumGroupsInGroups)+" Groups In Groups");
StatusForm->NumGroupsInGroupsLabel->Caption = IntToStr(TotalGroupsInGroupsCreated) + " Groups In Groups";
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::Button4Click(TObject *Sender)
{
if (MainForm->NumPlayersInGroups<MAX_PLAYERS_IN_GROUPS)
	{
    int group = StrToInt( PlayerGroupEdit->Text );
    if (group==-1) group = 0;

	int player = PlayerIDListBox->ItemIndex;
	if (MainForm->Dx_Play1->AddPlayerToGroup( MainForm->GroupIDs[group], MainForm->PlayerIDs[player] ))
    	{
        ShowMessage("Added Player #"+IntToStr(player)+" [id:"+IntToStr(MainForm->PlayerIDs[player])+"] To Group #"+IntToStr(group)+" [id:"+IntToStr(MainForm->GroupIDs[group])+"]");

	    // update status
        EnumPlayersInGroupButtonClick(this);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::Button10Click(TObject *Sender)
{
if (MainForm->NumPlayersInGroups>0)
	{
    // destroy a particular player in a particular group
	int group = StrToInt(PlayerGroupEdit->Text);
	int player = PlayerIDListBox->ItemIndex;
	ShowMessage("Deleting Player #"+IntToStr(player)+" [id:"+IntToStr(MainForm->PlayerIDs[player])+"] from Group #"+IntToStr(group)+" [id:"+IntToStr(MainForm->GroupIDs[group])+"]");
	if (MainForm->Dx_Play1->DeletePlayerFromGroup( MainForm->GroupIDs[group], MainForm->PlayerIDs[player] ))
    	{
        ShowMessage("deletion success");
        }
	else
        ShowMessage("deletion failed");

    // update status
    EnumPlayersInGroupButtonClick(this);
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::EnumAllPlayersButtonClick(TObject *Sender)
{
for (int i=0;i<MainForm->NumPlayers;i++) if (MainForm->PlayerNames[i]) delete MainForm->PlayerNames[i];

PlayerIDListBox->Items->Clear();
PlayerNamesListBox->Items->Clear();
GroupListBox->Items->Clear();
EnumPlayerIDsListBox->Items->Clear();

GUID guid;
if (MainForm->I_Am_The_Host) guid = MainForm->DPSessionDesc1->Application;
else guid = MainForm->Sessions[MainForm->SessionsListBox->ItemIndex]->Application;
MainForm->NumPlayers = 0;
MainForm->Dx_Play1->EnumPlayers( &guid, NULL, DPENUMPLAYERS_ALL );
if (MainForm->NumPlayers>0)
	{
    StatusForm->NumPlayersLabel->Caption = IntToStr(MainForm->NumPlayers)+" Players";
    for (int i=0;i<MainForm->NumPlayers;i++)
    	{
        PlayerIDListBox->Items->Add( IntToStr(MainForm->PlayerIDs[i]) );
        PlayerNamesListBox->Items->Add( MainForm->PlayerNames[i]->ShortNameA );
		GroupListBox->Items->Add("n/a");
        EnumPlayerIDsListBox->Items->Add( IntToStr(MainForm->PlayerIDs[i]) );
        }

	ListBox1->Items->Clear();
	for (int i=0;i<MainForm->Dx_Play1->NumPlayers;i++) ListBox1->Items->Add( IntToStr( (int) MainForm->Dx_Play1->PlayerIDs->Items[i] ) );
    }

// update the player group information
// - determine the available groups
EnumGroupsButtonClick(this);

// - determine which players are in group #n
for (int i=0;i<EnumGroupsListBox->Items->Count;i++)
   	{
    // find the players in the group
    PlayerGroupEdit->Text = IntToStr(i);
	EnumPlayersInGroupButtonClick(this);

    // update the group list box with the relevant information
    for (int j=0;j<EnumPlayerIDsListBox->Items->Count;j++)
    	{
        for (int k=0;k<PlayerIDListBox->Items->Count;k++)
        	{
            if (PlayerIDListBox->Items->Strings[k] == EnumPlayerIDsListBox->Items->Strings[j])
            	{
                if (GroupListBox->Items->Strings[k]=="n/a")
                	GroupListBox->Items->Strings[k] = EnumGroupsListBox->Items->Strings[i];
                else
                	GroupListBox->Items->Strings[k] = GroupListBox->Items->Strings[k] + ", "+EnumGroupsListBox->Items->Strings[i];
                break;
                }
            }
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::EnumPlayersInGroupButtonClick(TObject *Sender)
{
for (int i=0;i<MainForm->NumPlayersInGroups;i++)
	if (MainForm->PlayerInGroupsNames[i])
    	delete MainForm->PlayerInGroupsNames[i];

int group = StrToInt(PlayerGroupEdit->Text);

EnumPlayerIDsListBox->Items->Clear();
PlayerNamesListBox->Items->Clear();

MainForm->NumPlayersInGroups = 0;
//GUID guid = MainForm->DPSessionDesc1->Application;
//MainForm->Dx_Play1->EnumGroupPlayers( MainForm->GroupIDs[group], NULL, NULL, DPENUMPLAYERS_SESSION );
MainForm->Dx_Play1->EnumGroupPlayers( MainForm->GroupIDs[group], NULL, NULL, DPENUMPLAYERS_LOCAL );

if (MainForm->NumPlayersInGroups>0)
	{
    for (int i=0;i<MainForm->NumPlayersInGroups;i++)
    	{
        EnumPlayerIDsListBox->Items->Add( IntToStr(MainForm->PlayerInGroupsIDs[i]) );
        PlayerNamesListBox->Items->Add( MainForm->PlayerInGroupsNames[i]->ShortNameA );
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::FormHide(TObject *Sender)
{
while (MainForm->NumPlayers>0)
	{
    MainForm->Dx_Play1->DestroyPlayer( MainForm->PlayerIDs[MainForm->NumPlayers-1] );
    MainForm->NumPlayers--;
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayerSetupForm::Button3Click(TObject *Sender)
{
if (MainForm->NumPlayers>0)
	{
	int player = PlayerIDListBox->ItemIndex;
	if (player==-1) player=0;

    EnumAllPlayersButtonClick(this);

    DPName1->ShortNameA = PlayerNameEdit->Text;
	if (MainForm->Dx_Play1->SetPlayerName( MainForm->PlayerIDs[player], DPName1, DPSET_REMOTE ))
		{
	    ShowMessage("Player Name [#"+IntToStr(MainForm->PlayerIDs[player])+","+DPName1->ShortNameA+"] has been propagated to remove servers");
	    }
	else
		ShowMessage("Error: Could not update Player Name [#"+IntToStr(MainForm->PlayerIDs[player])+","+DPName1->ShortNameA+"]" );

	if (MainForm->Dx_Play1->SetPlayerName( MainForm->PlayerIDs[player], DPName1, DPSET_LOCAL ))
		{
	    ShowMessage("Player Name [#"+IntToStr(MainForm->PlayerIDs[player])+","+DPName1->ShortNameA+"] has been updated locally");
	    }
	else
		ShowMessage("Error: Could not update Player Name [#"+IntToStr(MainForm->PlayerIDs[player])+","+DPName1->ShortNameA+"]" );

    EnumAllPlayersButtonClick(this);
    }
}
//---------------------------------------------------------------------------
